import os
import time
import shutil
import getpass
import datetime
from selenium import webdriver


def addresource(name, file, type='bmp'):
    return f',\n\t\t{{\n\t\t\t\"type\": \"{type}\",\n\t\t\t\"name\": \"{name}\",\n\t\t\t\"file\": \"{file}\"\n\t\t}}'


def copyfile(src, dst):
    fdst = open(dst, 'w+', encoding='utf8')
    fdst.close()
    shutil.copy(src, dst)


# settings
uuid = '619861efbf301e1d29b86c000eb460da'
icon = ''
version = "1.0.0"
category = "face"  # face or app
# 开启此功能后, 编译前会暂停并显示appinfo.json中resources的name(即图片编号), 可以复制到c文件中使用
img_arry = False

# init
path = os.path.abspath('.')
name = os.path.basename(path)

# create files
if sum([len(x) for _, _, x in os.walk(path)]) == 1:
    os.makedirs(path+('\\resources\\images' if len(icon)
                      == 0 else '\\resources\\images\\icon'))
    os.makedirs(path+'\\.vscode')

    fp = open('.vscode\\launch.json', 'w', encoding='utf8')
    temp = path.replace('\\', "\\\\")
    fp.write(
        f"{{\n\t\"version\": \"0.2.0\",\n\t\"configurations\": [\n\t\t{{\n\t\t\t\"name\": \"MaibuBuild\",\n\t\t\t\"type\": \"python\",\n\t\t\t\"request\": \"launch\",\n\t\t\t\"program\": \"{temp}\\\\maibubuild.py\"\n\t}}\n\t]\n}}")
    fp.close()

    fp = open(f'watch{category}_{name}.c', 'w', encoding='utf8')
    fp.write(f'//Author: {getpass.getuser()}\n//Created: {datetime.date.today()}\n#include <stdlib.h>\n#include <stdio.h>\n#include <string.h>\n#include \"maibu_sdk.h\"\n#include \"maibu_res.h\"\n\nP_Window init_window()\n{{\n\t//创建窗口\n\tP_Window p_window = NULL;\n\tp_window = app_window_create();\n\tif (NULL == p_window)\n\t{{\n\t\treturn NULL;\n\t}}\n\n\t//do something\n\n\treturn (p_window);\n}}\n\nvoid time_change(enum SysEventType type, void *context)\n{{\n\t//时间更改\n\tif (type == SysEventTypeTimeChange)\n\t{{\n\t\t//do something\n\t}}\n}}\n\nint main()\n{{\n\t//创建日期时间设置窗口\n\tP_Window p_window = init_window();\n\t//放入窗口栈显示\n\tg_timer_window_id = app_window_stack_push(p_window);\n\t//注册一个事件通知回调，当有改变时，改变表盘显示数据\n\tmaibu_service_sys_event_subscribe(time_change);\n\treturn 0;\n}}')
    fp.close()

# build
else:
    os.makedirs(path+'\\temp')

    fp = open(f'appinfo.json', 'w', encoding='utf8')
    temp = 'true' if category == 'face' else 'false'
    fp.write(
        f'{{\n\t"uuid": "{uuid}",\n\t"name": "{name}",\n\t"icon": "{icon}",\n\t"version": "{version}",\n\t"watchface": "{temp}",\n\t"device_type": "120",\n\t"resources": [')

    isfirst = True
    for root, dirs, files in os.walk(f'{path}\\resources\\images'):
        if img_arry:
            temp_arry = f'{{{os.path.basename(root).upper()}_{0}' if not isfirst else ''

        j = 0
        for i in range(len(files)):
            if files[i] == 'desktop.ini':
                j += 1
                continue
            copyfile(
                f'{root}\\{files[i]}', f'{path}\\temp\\{os.path.basename(root)}_{i-j}.bmp')

            if isfirst:
                temp_arry = f'{{{os.path.basename(root).upper()}_{0}'

            if img_arry and i+1 < len(files):
                temp_arry += f' ,{os.path.basename(root).upper()}_{i+1-j}'

            temp = addresource(
                f'{os.path.basename(root).upper()}_{i-j}', f'{os.path.basename(root)}_{i-j}.bmp')
            temp2 = temp[1:] if isfirst else temp
            isfirst = False
            fp.write(temp2)

        if img_arry and len(temp_arry) > 0:
            print(temp_arry+'}\n')

    fp.write('\n\t]\n}')
    fp.close()

    if img_arry:
        os.system('pause')

    option = webdriver.ChromeOptions()
    # option.add_argument('headless')

    driver = webdriver.Chrome(chrome_options=option)
    driver.get('http://maibu.cc/watch/build/')
    driver.implicitly_wait(10)

    upload = driver.find_element_by_id('imagesID')

    temp_path = ''
    for root, dirs, files in os.walk(f'{path}\\temp'):
        for i in files:
            temp_path += f'{root}\\{i}\n'

    upload.send_keys(temp_path[:-1])

    upload = driver.find_element_by_id('appInfoID')
    upload.send_keys(f'{path}//appinfo.json')

    upload = driver.find_element_by_id('codeID')
    upload.send_keys(f'{path}//watch{category}_{name}.c')

    time.sleep(0.1)

    upload = driver.find_element_by_xpath('//form[@name="formConfig"]/input[@name="button"]')
    upload.click()

    time.sleep(0.1)

    upload = driver.find_element_by_xpath('//form[@name="formCode"]/input[@name="button"]')
    upload.click()

    time.sleep(0.1)

    upload = driver.find_element_by_xpath('//form[@name="formImages"]/input[@name="button"]')
    upload.click()

    # upload = driver.find_element_by_xpath('//div[@class="container_show"]/button')
    # upload.click()

    # time.sleep(1)

    # upload = driver.find_element_by_id('logID')
    # log = upload.get_attribute('value')
    # print(log)

    # time.sleep(1)

    # upload = driver.find_element_by_id('myCanvas')
    # img = upload.get_attribute('value')

    os.system('pause')
    driver.quit()
    shutil.rmtree(path+'\\temp')
